* Hash2 Fusion-N--N.sas : Exemple de fusion N  N inspir du cours "Procdure SQL";

* Cet exemple fonctionne, et ce mme si les tables en entre ne sont pas tries
  par la cl. Par contre, la table de sortie ne sera pas trie (une solution existe
  pour obtenir une table trie, mais plus complexe (voir Hash2A Fusion-N--N.sas).
  Pas de souci non plus si on a des donnes manquantes sur une ou l'autre des
  variables de l'une ou l'autre des tables en entre!!!;

* Version 1.0 (2013.04.16) Fonctionne en version 9.2 et plus de SAS;


LIBNAME EDUC "C:\SASCOURS\";

DATA EXTRACT(DROP= RC R);
* Dfinir les attributs des variables provenant de la table secondaire;
  IF 0 THEN SET EDUC.ADULTS;

* Charger la table HASH une seule fois, lors du traitement de la premire observation;
  IF _N_=1 THEN DO;
     DECLARE HASH MY_TABLE(DATASET: "EDUC.ADULTS", MULTIDATA:"Y", ORDERED:"Y", HASHEXP:10);
* Dclaration de l'objet HITER afin de pouvoir se dplacer dans la table ADULTS;
     DECLARE HITER ITER("MY_TABLE"); /* Mme nom que la table HASH (obligatoire) */
     RC = MY_TABLE.DEFINEKEY("FAM_NUM");
     RC = MY_TABLE.DEFINEDATA("ADLT_NAM");
     RC = MY_TABLE.DEFINEDONE( );
  END; 

* Lire chaque observation de la table principale;
  SET EDUC.CHILDREN;

* Tenter de trouver les informations requises de la table secondaire;
  IF FAM_NUM NE . THEN RC = MY_TABLE.FIND();
  IF RC NE 0 THEN DO;   /* La recherche dans la table secondaire a choue */
      CALL MISSING(ADLT_NAM); /* Rinitialiser les variables de la table secondaire */
      OUTPUT;           /* crit cet enfant */
  END;
  ELSE IF RC EQ 0 THEN DO; /* La recherche dans la table secondaire a russie */
      OUTPUT; /* crit cet enfant, mais vrifie s'il y a d'autres adultes pour cet enfant */
      MY_TABLE.HAS_NEXT(RESULT: R); /* Est-ce qu'il y a d'autres FAM_NUM dans ADULTS? */
      DO WHILE (R NE 0); /* Faire tant qu'il y en aura */
          RC= MY_TABLE.FIND_NEXT();
          OUTPUT;
          MY_TABLE.HAS_NEXT(RESULT: R);
      END;
  END;
RUN;


