* Hash3 Fusion_rptitive.sas : Pour chaque observation, plusieurs lectures
                                seront requises dans la table secondaire;

* Version 1.0 (2013.04.16) Fonctionne en version 9.1 et plus de SAS;
* Version 1.1 (2013.04.17) Pour plus de simplicit, remplac INFORMAT par FORMAT
                           pour ordonner les variables;


LIBNAME EDUC "c:\EDUCSAS\";
FILENAME BRUTES "c:\EDUCSAS\DATA\";
DATA MUNI;
  INFILE BRUTES(MUNICIP.DAT)  TRUNCOVER;
  INFORMAT CODE 5.  CITY $15.  PROV $2.;
  INPUT CODE CITY PROV;
  FORMAT CODE 5.  CITY $15.  PROV $2.; 
RUN;

DATA MIGR;
  INFILE CARDS TRUNCOVER;
  INPUT @1  FAM_NUM     $4.
        @6  LOC1         5.
        @12 DT_ARR1 YYMMN6.
        @19 LOC2         5.
        @25 DT_ARR2 YYMMN6.
        @32 LOC3         5.
        @37 DT_ARR3 YYMMN6.;
  FORMAT FAM_NUM $4.  LOC: 5.  DT_ARR: YYMMP7. ;
CARDS;
A108   106 199805   803 200507 
D101  1205 198511 
C103 12054 199104   101 200406  803 201002 
D109   806 198812   803 199707  806 200710 
RUN;



DATA HASH2(DROP=I RC CODE CITY PROV LOC1-LOC3);
* Ordonner les variables dans la table de sortie, via FORMAT;
  FORMAT FAM_NUM LOC1 DT_ARR1 CITY1 PROV1 LOC2 DT_ARR2 CITY2 PROV2
         LOC3 DT_ARR3 CITY3 PROV3;

* Dfinir les attributs des variables provenant de la table secondaire;
  IF 0 THEN SET WORK.MUNI;   

* Charger la table HASH une seule fois, lors du traitement de la premire observation;
  IF _N_=1 THEN DO;
     DECLARE HASH M(DATASET: "WORK.MUNI",HASHEXP: 6);
     M.DEFINEKEY("CODE");
     M.DEFINEDATA("CITY","PROV");
     M.DEFINEDONE( );
  END; 

* Mettre les variables recherches  manquant, au cas ou la recherche dans la table secondaire choue;
  CALL MISSING(PROV,CITY); 

* Lire chaque observation de la table principale;
  SET WORK.MIGR;

* Faire des vecteurs avec les localits actuelles, avec les nouveaux noms de
  villes trouvs et avec les codes de province trouvs - donner des formats aux
  nouvelles variables;
  ARRAY V_LOC (*) LOC1-LOC3;
  ARRAY V_CIT (*) $15  CITY1-CITY3;
  ARRAY V_PRO (*) $2 PROV1-PROV3;
  FORMAT CITY: $9.  PROV: $2.;

* Boucle  travers les localits  chercher;
  DO I=1 TO 3;

* Tenter de trouver les informations requises de la table secondaire;
    RC=M.FIND(KEY: V_LOC(I));

* Si localit trouve dans table secondaire, copier le nom de la ville
  et le code de province dans la bonne position de chaque vecteur;
    IF RC=0 THEN DO;
       V_CIT(I)=CITY;
       V_PRO(I)=PROV;
    END;
  END;
RUN;
