* Hash4 Slection-alatoire-contrainte.sas :
      Slectionne alatoirement des pices musicales d'un inventaire, afin de construire
      une "PLAY LIST" dont la dure totale ne dpasse pas XX minutes; 

* Version 1.0 (2013.04.16) Fonctionne en version 9.1 et plus de SAS;
* Version 1.1 (2013.04.17) Supprim un IF inutile (IF DUREE_TOTALE LT 60...);                      
* Version 1.2 (2013.06.03) Rintroduit le IF prcdent car en son absence, une dernire aurait pu
              tre choisie pour nous approcher de 45 minutes mais ne l'est pas...;                      
* Version 1.3 (2013.06.05) Ajoute la dcroissance du compteur (J=J-1) et modifie instruction
              LEAVE pour quitter si moins de 3 minutes restantes car aucune pice dure moins
              de 3 minutes;                      

* Vide la bibliothque WORK;
PROC DATASETS  LIBRARY=WORK  NOLIST  KILL;
QUIT;
OPTIONS NODATE NONUMBER LS=80 PS=50;

DATA INVENTAIRE;
    LENGTH ARTISTE TITRE $ 32;
    FORMAT DUREE TIME.;
    INPUT ARTISTE& TITRE& DUREE:STIMER.;  /* & = considre 2 blancs successifs comme dlm */
/* Plus de 1h30 de matriel */
DATALINES;
Alain Lefvre       Qubec, terre promise         4:02
Alexandre Tharaud   Suite En Sol - Les Triolets   3:55
Angle Dubeau       Mozart - Adagio               5:30
Catherine Major     Amadeus                       4:44
Alain Lefvre       La danse des petits lapins    3:33
Alexandre Tharaud   La Couperin (21E Ordre)       4:22
Hlne Guillemette  Il duello amoroso             5:33
Angle Dubeau       Assasin's Creed Revelations   3:22
Ccilia Bartoli     Gluck-Berenice, Che Fai       4:19
Christina Pluhar    Ah, vita bella !              3:51
Ensemble Lagoya     Bachianas Brasileiras No.5    5:21
Fabio Biondi        Mozart: Concertone, K.190     6:14
Filomena Moretti    J.S.Bach - Prelude BWV 998    5:54
Florence K          Hija de Cuba                  3:59
Fred Pellerin       Au commencement du monde      3:47
Karina Gauvin       Alcina - Si, son quella!      4:45
Vivica Genaux       Handel - La Scusa             3:59
Marc Hervieux       Puccini - Preludio sinfonico  4:25
Marc-Andr Hamelin  Chopin- Berceuse Op. 57       5:01
Ccilia Bartoli     Mendelssohn - Infelice        4:58
;
RUN;


/* Slection alatoire avec une contrainte de temps.
   La table HASH permet d'viter les remises de slection.  Le programme
   arrte juste avant que le temps total cumul ne dpasse le temps total demand. */

%LET DUREE_TOTALE = 45;  /* La dure dsire */

DATA PLAYLIST(KEEP=ARTISTE TITRE DUREE);
    DECLARE HASH PLAYLIST();
        PLAYLIST.DEFINEKEY("OBSERVATION");
        PLAYLIST.DEFINEDONE();
/* Convertir la dure totale en secondes au lieu de minutes */
    DUREE_TOTALE= &DUREE_TOTALE * 60;
/* N_OBS provient de l'option NOBS= de l'nonc SET */
    DO J= 1 TO N_OBS;
        OBSERVATION = INT(RANUNI(0) * N_OBS) + 1;
        IF PLAYLIST.FIND() EQ 0 THEN DO;
            J= J - 1; /* Dcroit le compteur, car le nombre de pices en inventaire peut-tre insuffisant. */
           CONTINUE; /* Existe dj: retourne  la boucle */
        END;
        PLAYLIST.ADD();
        SET INVENTAIRE NOBS=N_OBS POINT=OBSERVATION;
        /* Ignore la pice qui ferait dpasser la limite */
        DUREE_TOTALE= DUREE_TOTALE - DUREE;
        IF DUREE_TOTALE LT 0 THEN DUREE_TOTALE= DUREE_TOTALE + DUREE;
            ELSE OUTPUT;
/* Arrte si  l'intrieur de 60 secondes du temps total */
        IF DUREE_TOTALE LT 180 THEN LEAVE;  /* Quitte la boucle DO */
    END;
    STOP;  /* Un cycle de l'tape DATA */
RUN;
PROC PRINT  N="Nombre de pices: "  NOOBS;
    SUM DUREE;
RUN;
